package data;

use strict;

use vars qw( $data @allkeys );

*data = *main::data;

print "Saving data one-dimensional (simple) <parser/one_dimensional.pm>\n" if $main::debug;

sub save
{
	my $hash = shift;
	my ($key, $val);

	if (!@allkeys)
	{
		foreach (keys %$hash)
		{
			if (defined $main::config->{'print'}{lc ($_)})
			{
				push (@allkeys, $_);
			}
		}
	}

	foreach $key (@allkeys)
	{
		$val = $hash->{$key};
		if ($key eq 'Bytes')
		{
			$data->{'Bytes'}{'Total'} += $val;
		}
		else
		{
			$data->{$key}{$val}++;
		}
	}
}
