#!/usr/bin/perl

package data;

use strict;

use vars qw ( $data @allkeys );

*data = *main::data;
@allkeys = ();

print "Saving data two-dimensional (complex) <parser/two_dimensional.pm>\n" if $main::debug;

sub save
{
	my $hash = shift;

	if (!@allkeys)
	{
		foreach (keys %$hash)
		{
			if (defined $main::config->{'print'}{lc ($_)})
			{
				push (@allkeys, $_);
			}
		}
	}

	my $bytes;
	$bytes = (defined $hash->{'Bytes'} ? $hash->{'Bytes'} : undef);

	my ($key1, $val1, $key2, $val2, $amount);

	FIRST: foreach $key1 (@allkeys)
	{
		SECOND: foreach $key2 (@allkeys)
		{
			if ($key1 eq 'Bytes' and $key2 ne 'Bytes')
			{
				$val1 = 'General';
				$val2 = $hash->{$key2};
				$amount = $bytes;
			}
			elsif ($key1 ne 'Bytes' and $key2 eq 'Bytes')
			{
				$val1 = $hash->{$key1};
				$val2 = 'General';
				$amount = $bytes;
			}
			elsif ($key1 eq 'Bytes' and $key2 eq 'Bytes')
			{
				($val1, $val2) = ('General', 'General');
				$amount = $bytes;
			}
			else
			{
				$val1 = $hash->{$key1};
				$val2 = $hash->{$key2};
				$amount = 1;
			}

			if (!defined $data->{$key1}) { $data->{$key1} = {}; }
			if (!defined $data->{$key1}{$val1}) { $data->{$key1}{$val1} = {}; }
			if (!defined $data->{$key1}{$val1}{$key2}) { $data->{$key1}{$val1}{$key2} = {}; }
			if (!defined $data->{$key1}{$val1}{$key2}{$val2}) { $data->{$key1}{$val1}{$key2}{$val2} = 0; }

#			if (!defined $amount) { print "\$amount: {$key1}{$val1}{$key2}{$val2}\n"; }
#			if (!defined $val2) { print "\$val2: {$key1}{$val1}{$key2}{} = $amount\n"; }

			$data->{$key1}{$val1}{$key2}{$val2} += $amount;
		}
	}
}
